---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------Addon Constants and variables-------------
---------------------Addon Constants and variables-------------
---------------------Addon Constants and variables-------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------



local SuperRaidRoll_Version="2.0";



local SRR_Item=nil;
local SRR_Raid=nil;
local SRR_Active=false;



SuperRaidRoll_Options = {
	["long"] = true,
}







---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------On load and defaults----------------------
---------------------On load and defaults----------------------
---------------------On load and defaults----------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------



--At startup
function SRR_OnLoad() 
	SlashCmdList["SRRSLASH"] = SRR_Handler;	
	SLASH_SRRSLASH1 = "/srr";
	SLASH_SRRSLASH2 = "/rr";

	SRR_Report("SuperRaidRoll version "..SuperRaidRoll_Version.." loaded. Developed by SuperCommander");
	SRR_Report("/rr or /srr for options [short, long, list, help, ITEM]");

	this:RegisterEvent("CHAT_MSG_SYSTEM");
end







---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
-----------------Slashcommands and registering events----------
-----------------Slashcommands and registering events----------
-----------------Slashcommands and registering events----------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------



--Slashcommand handler
function SRR_Handler(msg)
		
	--Check for raid or party
	if (GetNumRaidMembers()>0) then 
		SRR_Raid="raid";
	elseif (GetNumPartyMembers()>0) then 
		SRR_Raid="party";
	else 
		SRR_Raid=nil;
	end
	
	if (string.lower(msg)=="long") then
		SuperRaidRoll_Options.long=true;
		SRR_Report("SRR does now show the rolling list");
	elseif (string.lower(msg)=="short") then
		SuperRaidRoll_Options.long=false;
		SRR_Report("SRR does no longer show the rolling list");
	elseif (string.lower(msg)=="list") and (SRR_Raid~=nil) then
		SRR_List();
	elseif (string.lower(msg)=="help") then
		SRR_Report("/rr or /srr help|long|short|list|ITEM");
	else

		--Set item and activate roller
		SRR_Item=msg;					
		SRR_Active=true;

		if (SRR_Raid=="raid") then 
			SRR_RaidRoller();
		elseif (SRR_Raid=="party") then 
			SRR_PartyRoller();
		else 
			SRR_Report("ERROR. You are not in a party.");
		end
	end
end







---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------Report functions--------------------------
---------------------Report functions--------------------------
---------------------Report functions--------------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------



--Printing messages in the format: [SRR]: MESSAGE
function SRR_Print(msg)
	SendChatMessage("[SRR]: "..msg, SRR_Raid);
end



--Reporting messages
function SRR_Report(msg)
	DEFAULT_CHAT_FRAME:AddMessage("[SuperRaidRoll]: "..msg, 0.56, 0.11, 0.59);
end







---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
-----------------------Rolling functions-----------------------
-----------------------Rolling functions-----------------------
-----------------------Rolling functions-----------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------



--Prints the list
function SRR_List()
	if (GetNumRaidMembers()>0) then
		
		local raidNum=GetNumRaidMembers(); 
		local out=""; 
		local i=1;
		
		--Printing 10 players a time
		for i=1, raidNum do
			out = out..UnitName("raid"..i).."="..i.."; ";
			if (i==10 or i==20 or i==30 or i==40) then
				SRR_Print(out);	
				out="";
			end
		end	
		if out~="" then
			SRR_Print(out);
		end
	else
		
		local pNum=GetNumPartyMembers(); 
		local out= ""; 
		local i=1;
		
		--Puts together the other party members
		for i=1, pNum do 
			out=out..UnitName("party"..i).."="..i.."; ";	
		end 
		
		--This adds the player's name to the end
		out=out..UnitName("player").."="..(pNum+1)..";";
		
		SRR_Print(out);	
	end
end


--Makes the roll for a party
function SRR_PartyRoller() 

	local pNum = GetNumPartyMembers();

	if SuperRaidRoll_Options.long then 
		SRR_Print("Now rolling for: "..SRR_Item);
		SRR_List();
	end

	--This does the roll the addon goes by
	RandomRoll(1,pNum+1);						
end


--Makes the roll for a raid
function SRR_RaidRoller() 
	
	local raidNum = GetNumRaidMembers();

	if SuperRaidRoll_Options.long then 
		SRR_Print("Now rolling for: "..SRR_Item);
		SRR_List();
	end

	--This does the random roll which the addon goes by
	RandomRoll(1,raidNum);			
end







---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------
-----------------------Main event handler----------------------
-----------------------Main event handler----------------------
-----------------------Main event handler----------------------
---------------------------------------------------------------
---------------------------------------------------------------
---------------------------------------------------------------



--Handles when the roll comes back from server, decides who wins
function SRR_OnEvent(event,arg1)

	local SRR_Name; 
	local SRR_Player=UnitName("player");

	if((SRR_Active) and (strfind(event,"CHAT_MSG_SYSTEM")~=nil) and (strfind(arg1,SRR_Player.." rolls ")~=nil)) then
		
		local Data={}; 
		local i=0;

		--Search for spaces in the string
		for value in string.gmatch(arg1, "[^".." ".."]+") do

			--Increment key & add the value from string		
			i = i + 1; 
			Data[i] = value;				
		end

		--Third thing in the string will be the roll
		local SRR_Roll = Data[3];					

		if (SRR_Raid=="party") then

			--Roll was 1 more than # of party
			if ((""..(GetNumPartyMembers()+1))==SRR_Roll) then
				
				--It must be the player who won
				SRR_Name = UnitName("player");			
			else
				SRR_Name = UnitName("party"..SRR_Roll);
			end	

		elseif (SRR_Raid=="raid") then
			SRR_Name = UnitName("raid"..SRR_Roll);				
		end

		SRR_Print("<<"..SRR_Name.." wins "..SRR_Item..">>");	
		SRR_Active=false;
	end
end